<?php

class DispletRetsIdxEmails{
	public function get_admin_email_address(){
		$displet_rets_idx_option = DispletRetsIdxSettings::get_option();
		$admin_email = (!empty($displet_rets_idx_option['displet_rets_idx_option_email'])) ? $displet_rets_idx_option['displet_rets_idx_option_email'] : get_option('admin_email');
		if (strpos($admin_email, ',') !== false) {
			$admin_emails = explode(',', $admin_email);
			$admin_email = array();
			foreach ($admin_emails as $email) {
				$admin_email[] = trim($email);
			}
		}
		return $admin_email;
	}

	public function set_admin_email_as_sender($email_address){
		$displet_rets_idx_option = DispletRetsIdxSettings::get_option();
		if (!empty($displet_rets_idx_option['displet_rets_idx_option_email_from_address'])) {
			$email_address = $displet_rets_idx_option['displet_rets_idx_option_email_from_address'];
		}
		return $email_address;
	}

	public function set_admin_name_as_sender($email_name){
		$displet_rets_idx_option = DispletRetsIdxSettings::get_option();
		if (!empty($displet_rets_idx_option['displet_rets_idx_option_email_from_name'])) {
			$email_name = $displet_rets_idx_option['displet_rets_idx_option_email_from_name'];
		}
		return $email_name;
	}

	public function send_property_showing_request(){
		// Check nonce for security
		check_ajax_referer('displet_property_showing_nonce');

		if (isset($_POST['action']) && $_POST['action'] == 'displet_property_showing_request'){
			if (!empty($_POST['name']) && !empty($_POST['email']) && !empty($_POST['phone'])) {
				if (is_email($_POST['email'])) {
					// Set admin as email sender
					add_filter('wp_mail_from', array('DispletRetsIdxEmails', 'set_admin_email_as_sender'));
					add_filter('wp_mail_from_name',array('DispletRetsIdxEmails', 'set_admin_name_as_sender'));

					// Get admin recipient email address
					$admin_email = self::get_admin_email_address();

					$message = 
						$_POST['url'] . "\r\n" .
						'Property: ' . trim($_POST['address']) . ', ' . trim($_POST['city']) . ', ' . trim($_POST['state']) . ' ' . trim($_POST['zip']) . "\r\n" .
						'Name: ' . $_POST['name'] . "\r\n" .
						'Email: ' . $_POST['email'] . "\r\n" .
						'Phone: ' . $_POST['phone'] . "\r\n" .
						'Appointment 1: ' . $_POST['appointment1'] . "\r\n" .
						'Appointment 2: ' . $_POST['appointment2'] . "\r\n" .
						'Message: ' . $_POST['message'];

					wp_mail($admin_email, 'Property Showing Request', $message);

					// Remove admin as email sender
					remove_filter('wp_mail_from', array('DispletRetsIdxEmails', 'set_admin_email_as_sender'));
					remove_filter('wp_mail_from_name',array('DispletRetsIdxEmails', 'set_admin_name_as_sender'));
					
					echo 'Your request has been sent.';
				}
				else{
					echo 'Please enter a valid email address.';
				}
			}
			else{
				echo 'Please complete the required fields.';
			}
			die();
		}
		
		echo 'We\'re sorry, there was an error processing your request. Please try again.';
		die();
	}

	public function send_email_to_friend_request(){
		// Check nonce for security
		check_ajax_referer('displet_email_friend_nonce');

		if (isset($_POST['action']) && $_POST['action'] == 'displet_email_friend_request'){
			if (!empty($_POST['email']) && is_email($_POST['email'])) {
				// Set admin as email sender
				add_filter('wp_mail_from', array('DispletRetsIdxEmails', 'set_admin_email_as_sender'));
				add_filter('wp_mail_from_name',array('DispletRetsIdxEmails', 'set_admin_name_as_sender'));

				// Get admin recipient email address
				$admin_email = self::get_admin_email_address();

				// Message to admin
				$admin_message =
					$_POST['url'] . "\r\n" .
					'Property: ' . trim($_POST['address']) . ', ' . trim($_POST['city']) . ', ' . trim($_POST['state']) . ' ' . trim($_POST['zip']) . "\r\n" .
					'Friend Name: ' . $_POST['name'] . "\r\n" .
					'Friend Email: ' . $_POST['email'] . "\r\n" .
					'User Message: ' . $_POST['message'];
				wp_mail($admin_email, 'Property Emailed To A Friend from ' . site_url(), $admin_message);

				// Message to friend
				$friend_message =
					$_POST['url'] . "\r\n" .
					'Property: ' . $_POST['address'] . ', ' . $_POST['city'] . ', ' . $_POST['state'] . ' ' . $_POST['zip'] . "\r\n" .
					'Message from ' . $_POST['name'] . ': ' . $_POST['message'];

				wp_mail($_POST['email'], $_POST['name'] . ' Thinks You\'ll Like ' . $_POST['address'], $friend_message);
					
				// Remove admin as email sender
				remove_filter('wp_mail_from', array('DispletRetsIdxEmails', 'set_admin_email_as_sender'));
				remove_filter('wp_mail_from_name',array('DispletRetsIdxEmails', 'set_admin_name_as_sender'));
				
				echo 'Your message has been sent.';
			}
			else{
				echo 'Please enter a valid email address.';
			}
			die();
		}
		
		echo 'We\'re sorry, there was an error processing your request. Please try again.';
		die();
	}
}

add_action('wp_ajax_displet_property_showing_request', array('DispletRetsIdxEmails', 'send_property_showing_request'));
add_action('wp_ajax_displet_email_friend_request', array('DispletRetsIdxEmails', 'send_email_to_friend_request'));
///* Shouldn't be needed as can't do without having logged in
add_action('wp_ajax_nopriv_displet_property_showing_request', array('DispletRetsIdxEmails', 'send_property_showing_request'));
add_action('wp_ajax_nopriv_displet_email_friend_request', array('DispletRetsIdxEmails', 'send_email_to_friend_request'));
//*/

/* Sets to HTML formatting
function displet_rets_idx_format_emails_as_html(){
    return "text/html";
}
add_filter('wp_mail_content_type','displet_rets_idx_format_emails_as_html');
// Send Email between adding and removing
remove_filter('wp_mail_content_type','displet_rets_idx_format_emails_as_html');
*/

?>