<?php

class DispletRetsIdxPropertyDetails{
	function create_global_model() {
		$displet_rets_idx_option = DispletRetsIdxSettings::get_option();
		$page_id = $displet_rets_idx_option['displet_rets_idx_option_property_details_page_id'];
		$model = array(
			'property_id' => get_query_var('property_id'),
			'facebook_app_id' => $displet_rets_idx_option['displet_rets_idx_option_facebook_app_id'],
			'color_scheme' => $displet_rets_idx_option['displet_rets_idx_option_color_scheme'],
			'google_auth_url' => DispletRetsIdxGoogle::get_authorization_url()
		);
		if (is_page($page_id) && !empty($model['property_id'])) {
			// Get raw data from json API server-side for crawlable content
			$model['is_displet_api'] = (!empty($displet_rets_idx_option['displet_rets_idx_option_displet_app_key'])) ? true : false;
			if ($model['is_displet_api']) {
				$model['app_key'] = $displet_rets_idx_option['displet_rets_idx_option_displet_app_key'];
			}
			$listing = DispletRetsIdxQuery::get_listing($model);
			global $displet_property_details_model;
			$displet_property_details_model = array_merge($model, $listing);
		}
	}

	function replace_wp_title($title) {
		$displet_rets_idx_option = DispletRetsIdxSettings::get_option();
		$page_id = $displet_rets_idx_option['displet_rets_idx_option_property_details_page_id'];
		if (is_page($page_id) && get_query_var('property_id')) {
			global $displet_property_details_model;
			$title = $displet_property_details_model['listings'][0]->address;
		}
		return $title;
	}

	function replace_page_title($title) {
		$displet_rets_idx_option = DispletRetsIdxSettings::get_option();
		$page_id = $displet_rets_idx_option['displet_rets_idx_option_property_details_page_id'];
		global $post, $id;
		if (is_page($page_id) && get_query_var('property_id') && $id == $post->ID && in_the_loop() && self::is_referral_function('the_title')) {
			global $displet_property_details_model;
			$title = DispletRetsIdxLoad::get_template('displet-property-details-page-title.php', $displet_property_details_model);
		}
		return $title;
	}

	function replace_page_content($content) {
		$displet_rets_idx_option = DispletRetsIdxSettings::get_option();
		$page_id = $displet_rets_idx_option['displet_rets_idx_option_property_details_page_id'];
		if (is_page($page_id) && get_query_var('property_id') && in_the_loop()) {
			global $displet_property_details_model;
			$content = '<!-- Displet Property ID: ' . $displet_property_details_model['property_id'] . ' -->';
			$content .= DispletRetsIdxLoad::get_template('displet-facebook-login-jquery.php', $displet_property_details_model);
			//$content .= DispletRetsIdxLoad::get_template('displet-google-login-jquery.php', $displet_property_details_model);
			$content .= DispletRetsIdxLoad::get_template('displet-property-details-page-jquery.php', $displet_property_details_model);
			$content .= DispletRetsIdxLoad::get_template('displet-property-details-page-content.php', $displet_property_details_model);
			$content .= DispletRetsIdxLoad::get_template('displet-property-details-page-popups.php', $displet_property_details_model);
		}
		return $content;
	}

	function generate_rewrite_rules(){
		$displet_rets_idx_option = DispletRetsIdxSettings::get_option();
		$id = $displet_rets_idx_option['displet_rets_idx_option_property_details_page_id'];
		$pagename = get_page($id)->post_name;
		$rule = $pagename . '/(\d*)/?(.*)/?$';
		$rewrite = 'index.php?pagename=' . $pagename . '&property_id=$matches[1]';
		$property_id_tag = '%property_id%';
		$args = array(
			'paged' => false
		);
		add_rewrite_tag($property_id_tag, $rule);
		add_rewrite_rule($rule, $rewrite, 'top');
	}

	function flush_rewrite_rules(){
		$rules = get_option('rewrite_rules');
		$displet_rets_idx_option = DispletRetsIdxSettings::get_option();
		$id = $displet_rets_idx_option['displet_rets_idx_option_property_details_page_id'];
		$pagename = get_page($id)->post_name;
		if (!isset($rules[$pagename . '/(\d*)/?(.*)/?$'])){
			global $wp_rewrite;
		   	$wp_rewrite->flush_rules();
		}
	}

	function replace_canonical(){
		if(get_query_var('property_id')){
			remove_action('wp_head', 'rel_canonical');
			add_action('wp_head', array('DispletRetsIdxPropertyDetails', 'add_new_canonical'), 1);
		}
	}

	function add_new_canonical(){
		global $displet_property_details_model;
		$displet_rets_idx_option = DispletRetsIdxSettings::get_option();
		$id = $displet_rets_idx_option['displet_rets_idx_option_property_details_page_id'];
		$property_id = get_query_var('property_id');
		$address = $displet_property_details_model['listings'][0]->location->address;
	    $link = rtrim(get_permalink($id), '/') . '/' . $property_id . '/' . stripslashes(str_replace(' ', '-', $address));
	    echo '<link rel="canonical" href="' . esc_url($link) . '" />';
	}

	function remove_yoasts_canonical($canonical) {
		global $post;
		if (get_query_var('property_id')) {
	    	$canonical = false;
	    }
		return $canonical;
	}

	// Whitelist query var for Yoast's redirect option
	/* Should work but doesn't :-( - $_GET['property_id'] fails in Yoast's code, whereas get_query_var('property_id') doesn't
	function whitelist_query_var_from_yoasts_redirect($whitelisted_extravars) {
		$whitelisted_extravars = array('property_id');
		return $whitelisted_extravars;
	}
	*/

	// Determine referral function (useful to prevent unintentional title adjustments in menus)
	function is_referral_function($f) {
		$aray = debug_backtrace(DEBUG_BACKTRACE_IGNORE_ARGS);
		foreach($aray as $a) {	$aa[] = $a["function"];	}
		if(in_array($f,$aa)) { return true; }
		return false;
	}

}

add_action('wp', array('DispletRetsIdxPropertyDetails', 'create_global_model'));
add_filter('wp_title', array('DispletRetsIdxPropertyDetails', 'replace_wp_title'), 1000000);
add_filter('the_title', array('DispletRetsIdxPropertyDetails', 'replace_page_title'));
add_filter('the_content', array('DispletRetsIdxPropertyDetails', 'replace_page_content'));
add_action('init', array('DispletRetsIdxPropertyDetails', 'generate_rewrite_rules'));
add_action('wp_loaded', array('DispletRetsIdxPropertyDetails', 'flush_rewrite_rules'));
add_action('template_redirect', array('DispletRetsIdxPropertyDetails', 'replace_canonical'));
add_filter('wpseo_canonical', array('DispletRetsIdxPropertyDetails', 'remove_yoasts_canonical'));
//add_filter('wpseo_whitelist_permalink_vars', array('DispletRetsIdxPropertyDetails', 'whitelist_query_var_from_yoasts_redirect'));

?>