/*! jQuery Cookie Plugin
* https://github.com/carhartl/jquery-cookie */
(function(e){e.cookie=function(t,n,r){if(arguments.length>1&&(!/Object/.test(Object.prototype.toString.call(n))||n===null||n===undefined)){r=e.extend({},r);if(n===null||n===undefined){r.expires=-1}if(typeof r.expires==="number"){var i=r.expires,s=r.expires=new Date;s.setDate(s.getDate()+i)}n=String(n);return document.cookie=[encodeURIComponent(t),"=",r.raw?n:encodeURIComponent(n),r.expires?"; expires="+r.expires.toUTCString():"",r.path?"; path="+r.path:"",r.domain?"; domain="+r.domain:"",r.secure?"; secure":""].join("")}r=n||{};var o=r.raw?function(e){return e}:decodeURIComponent;var u=document.cookie.split("; ");for(var a=0,f;f=u[a]&&u[a].split("=");a++){if(o(f[0])===t)return o(f[1]||"")}return null}})(jQuery);

/*********************
Global Functions
*********************/

function displetretsidxCommasToNumber(val){
	if (val){
		while (/(\d+)(\d{3})/.test(val.toString())){
			val = val.toString().replace(/(\d+)(\d{3})/, '$1'+','+'$2');
		}
	}
	return val;
}

/*********************
API Functions
*********************/

function loadDispletAPIListings(query_url, is_displet_api) {jQuery(function($){
	$('.displet-listings-loading').show();
	// Use JSON to get the content
	if (is_displet_api) {
		query_url += '&callback=?';
	}
	$.getJSON(query_url, null, function(data) {
		// Translate variables
		if (is_displet_api) {
			data.meta.first = parseInt(data.meta.limit) * parseInt(data.meta.page) - parseInt(data.meta.limit) + 1;
			data.meta.last = parseInt(data.meta.first) + parseInt(data.meta.limit) - 1;
			if (data.meta.count < data.meta.last) {
				data.meta.last = data.meta.count;
			}
		}
		else{
			data.meta.count = data.meta.total;
			data.results = data.listings;
		}
		if (data.meta.count > 0){
			// Fill controls
			$('.displet-no-results').hide();
			$('.displet-total-listings-value').html(displetretsidxCommasToNumber(data.meta.count));
			$('.displet-first-listings-value').html(data.meta.first);
			$('.displet-last-listings-value').html(data.meta.last);
			// Populate listings from results
			$('.displet_json_response .displet-listing.displet-current').hide();
			$('#displet-listings').show();
			$('#displet-map').show();
			var i = 1;
			var displet_map_listings_array = new Array();
			var current_lat_total = 0;
			var current_long_total = 0;
			$.each(data.results, function() {
				// Translate variables
				if (is_displet_api) {
					this.address = this.street_number + ' ' + this.street_name + ' ' + this.street_post_dir;
					if (this.half_baths != undefined && this.half_baths != '') {
						var half_baths = '/' + this.half_baths;
					}
					else{
						var half_baths = '';
					}
					this.bathrooms = this.full_baths + half_baths;
				}
				else{
					this.sysid = this.id;
					this.list_price = this.attributes.price;
					this.address = this.location.address;
					this.city = this.location.name;
					this.state = this.location.state;
					this.zip = this.location.zip;
					this.num_bedrooms = this.attributes.bedrooms;
					this.bathrooms = this.attributes.bathrooms;
					this.square_feet = this.attributes.square_feet;
					this.property_type = this.category.name;
					this.mls_number = this.attributes.mls_id;
					this.internet_remarks = this.body;
					this.latitude = this.location.latitude;
					this.longitude = this.location.longitude;
				}
				// Swap phones, emails and URLs from description
				if (this.internet_remarks != undefined) {
					var phone = /([0-9]{3})[-. ]?([0-9]{4})/g;
					var email = /([\S]+)@([\S]+)/g;
					var website = /([\S]+)\.com([\S]+)/g;
					var new_body = this.internet_remarks.replace(phone, 'XXX-XXXX').replace(email, 'XXXX@XXXX').replace(website, 'http://.com');
					// Limit length of remarks
    				var truncated_body_array = new_body.split(/\s+/, 48);
    				var complete_body_array = new_body.split(/\s+/);
    				if (complete_body_array.length > truncated_body_array.length) {
    					this.internet_remarks = truncated_body_array.join(' ') + ' ...';
    				}
    				else{
    					this.internet_remarks = new_body;
    				}
				}
				// Find listing
				var element = '.displet_json_response .displet-listing-' + i;
				$(element + '.displet-current').show();
				// Create href
				if (this.sysid != undefined) {
					this.permalink = $(element).attr('name') + this.sysid;
					if (this.address) {
						this.permalink += '/' + this.address.replace(/ /g, '-');
					}
				}
				// Populate listing if value exists, else hide container element
				if (this.permalink) $(element).attr('href', this.permalink);
				if (this.list_price != undefined) $(element).find('.displet-price-value').html(displetretsidxCommasToNumber(this.list_price));
				(this.images != undefined && this.images[0] != undefined && this.images[0].src != undefined) ? $(element).find('.displet-image-value').css('background-image', 'url(' + this.images[0].src + ')') : $(element).find('.displet-image').hide();
				(this.address != undefined) ? $(element).find('.displet-address-value').html(this.address) : $(element).find('.displet-address').hide();
				(this.city != undefined) ? $(element).find('.displet-city-value').html(this.city) : $(element).find('.displet-city').hide();
				(this.state != undefined) ? $(element).find('.displet-state-value').html(this.state) : $(element).find('.displet-state').hide();
				(this.zip != undefined) ? $(element).find('.displet-zip-value').html(this.zip) : $(element).find('.displet-zip').hide();
				(this.num_bedrooms != undefined) ? $(element).find('.displet-beds-value').html(this.num_bedrooms) : $(element).find('.displet-beds').hide();
				(this.bathrooms != undefined) ? $(element).find('.displet-baths-value').html(this.bathrooms) : $(element).find('.displet-baths').hide();
				(this.square_feet != undefined) ? $(element).find('.displet-square-feet-value').html(displetretsidxCommasToNumber(this.square_feet)) : $(element).find('.displet-square-feet').hide();
				(this.property_type != undefined) ? $(element).find('.displet-property-type-value').html(this.property_type.replace('Houses', 'House').replace('Condos, Townhouses & Apts for Sale', 'Condo / Townhouse / Apt')) : $(element).find('.displet-property-type').hide();
				(this.mls_number != undefined) ? $(element).find('.displet-mls-value').html(this.mls_number) : $(element).find('.displet-mls').hide();
				(this.internet_remarks != undefined) ? $(element).find('.displet-description-value').html(this.internet_remarks) : $(element).find('.displet-description').hide();
				// Add map marker
				if (this.latitude != undefined && this.longitude != undefined) {
					var this_listing = [parseFloat(this.latitude), parseFloat(this.longitude), this.list_price, this.address];
					current_lat_total += parseFloat(this.latitude);
					current_long_total += parseFloat(this.longitude);
					displet_map_listings_array.push(this_listing);
				}
				i++;
			});
			// Hovertrans
			$('#displet-dynamic').data('displet_listings').hovertrans();
			// Render map
			renderDispletMap(displet_map_listings_array, current_lat_total, current_long_total);
			// Save query for pagination use
			if (is_displet_api) {
				query_url = query_url.replace('&callback=?', '');
			}
			$('.displet-previous-listings-link').attr('displet_query', query_url);
			$('.displet-next-listings-link').attr('displet_query', query_url);
		}
		// No listings
		else{
			// Fill controls
			$('.displet-total-listings-value').html('0');
			$('.displet-first-listings-value').html('0');
			$('.displet-last-listings-value').html('0');
			// Fill listings
			$('#displet-listings').hide();
			$('#displet-map').hide();
			$('.displet-no-results').show();
		}
		$('.displet-listings-loading').hide();
		// Save last query as cookie to recall user's sorting preference
		$.cookie('displet_last_viewed_listings_query', query_url);
	});
});}

/*********************
Search Form Functions
*********************/

jQuery(document).ready(function($){
	// Reset property type to none when is_foreclosure=Y is selected
	$('#displet-search-form input[name="is_foreclosure"][value="Y"]').click(function(){
		$('#displet-search-form select[name="property_type"]').val('none');
	});
	// Reset foreclosure=Y to any when property type is selected
	$('#displet-search-form select[name="property_type"]').bind('change', function(){
		if ($('#displet-search-form input[name="is_foreclosure"][value="Y"]').is(':checked') && $(this).val() != 'none') {
			$('#displet-search-form input[name="is_foreclosure"][value="none"]').attr('checked', 'checked');
		}
	});
});

/*********************
Property Details Functions
*********************/

function displetSmallToLargePhotos(){jQuery(function($){
	$('#displet-property-details .displet-photos-thumbs-value .displet-image').click(function(){
		$('#displet-property-details .displet-photos-large-value .displet-image img').attr('src', $(this).children('img').attr('src'));
		$('#displet-property-details .displet-photos-large-value .displet-image').css('background-image', $(this).css('background-image'));
	});
});}

function displetHideShowingRequestPopup(){jQuery(function($){
	$('#displet-property-details-popups .displet-request-showing-popup-wrapper').hide();
	$('html, body').removeClass('displet-request-showing-popup');
});}

function displetHideEmailFriendPopup(){jQuery(function($){
	$('#displet-property-details-popups .displet-email-friend-popup-wrapper').hide();
	$('html, body').removeClass('displet-email-friend-popup');
});}

function displetShowUserRegistrationPopup(){jQuery(function($){
	$('#displet-property-details-popups .displet-user-registration-popup-wrapper').show();
	$('html, body').addClass('displet-user-registration-popup');
});}

function displetHideUserRegistrationPopup(){jQuery(function($){
	$('#displet-property-details-popups .displet-user-registration-popup-wrapper').hide();
	$('html, body').removeClass('displet-user-registration-popup');
});}

jQuery(document).ready(function($){
	// Map / Street View tabs
	$('#displet-property-details .displet-map-tabs a').click(function(){
		if (!$(this).hasClass('displet-active')) {
			if ($(this).hasClass('displet-map-select')) {
				$('#displet-property-details .displet-map .displet-map-iframe').show();
				$('#displet-property-details .displet-map .displet-street-view-iframe').hide();
				$('#displet-property-details .displet-map-tabs .displet-active').removeClass('displet-active');
				$(this).addClass('displet-active');
			}
			else{
				$('#displet-property-details .displet-map .displet-street-view-iframe').show();
				$('#displet-property-details .displet-map .displet-map-iframe').hide();
				$('#displet-property-details .displet-map-tabs .displet-active').removeClass('displet-active');
				$(this).addClass('displet-active');
			}
		}
	});
	// Request showing popup
	$('#displet-property-details .displet-request-showing').click(function(){
		$('#displet-property-details-popups .displet-request-showing-popup-wrapper').show();
		$('html, body').addClass('displet-request-showing-popup');
		// Datepicker
		$("#showing_request_appointment1_at").datepicker({ dateFormat: 'mm-dd-yy' });
		$("#showing_request_appointment2_at").datepicker({ dateFormat: 'mm-dd-yy' });
	});
	$('#displet-property-details-popups .displet-request-showing-popup .displet-close, #displet-property-details-popups .displet-request-showing-popup-wrapper .displet-popup-back').click(function(){
		displetHideShowingRequestPopup();
	});
	$('#displet-property-details-popups .displet-user-registration-popup .displet-login-expand-contract').click(function(){
		if (!$(this).hasClass('displet-expanded')) {
			$('#displet-property-details-popups .displet-user-registration-popup .displet-login-form').slideDown(300);
			$(this).addClass('displet-expanded');
		}
		else{
			$('#displet-property-details-popups .displet-user-registration-popup .displet-login-form').slideUp(300);
			$(this).removeClass('displet-expanded');
		}
	});
	// Email friend popup
	$('#displet-property-details .displet-email-friend').click(function(){
		$('#displet-property-details-popups .displet-email-friend-popup-wrapper').show();
		$('html, body').addClass('displet-email-friend-popup');
	});
	$('#displet-property-details-popups .displet-email-friend-popup .displet-close, #displet-property-details-popups .displet-email-friend-popup-wrapper .displet-popup-back').click(function(){
		displetHideEmailFriendPopup();
	});
	// User registration popup
	/* Not yet implemented
	$('#displet-property-details .displet-user-registration').click(function(){
		displetShowUserRegistrationPopup();
		$('#displet-property-details-popups .displet-user-registration-popup .displet-close').show();
	});
	$('#displet-property-details-popups .displet-user-registration-popup .displet-close').click(function(){
		displetHideUserRegistrationPopup();
	});
	*/
});

/*********************
Dynamic View Functions
*********************/

jQuery(document).ready(function($){

	// Toggle view
	$('#displet-dynamic .displet-tile-view').click(function() {
		if (!$(this).hasClass('current')) {
			$('#displet-dynamic').displet_listings('show_tile');
		}
	});
	$('#displet-dynamic .displet-list-view').click(function() {
		if (!$(this).hasClass('current')) {
			$('#displet-dynamic').displet_listings('show_vertical');
		}
	});
	$('#displet-dynamic .displet-map-view').click(function() {
		if (!$(this).hasClass('current')) {
			$('#displet-dynamic').displet_listings('show_map');
		}
	});

});

/*********************
Tile/Vertical Listings Functions
*********************/

;(function ($) {
	$.widget('displetreader.displet_listings', {
		'options': {
			'first_selector': 'span.displet-first-listings-value',
			'last_selector': 'span.displet-last-listings-value',
			'total_selector': 'span.displet-total-listings-value',
			'previous_selector': 'a.displet-previous-listings-link',
			'next_selector': 'a.displet-next-listings-link',
			'sortby_selector': '.displet-listings-sortby',
			'listing_selector': 'a.displet-listing',
			'tile_listing_selector': 'a.displet-tile-listing',
			'vertical_listing_selector': 'a.displet-vertical-listing',
			'selector_map': {
				'list-price': '.displet-price-value'
			},
		},
		'_create': function () {
			var el = this.element;
			var o = this.options;
			var self = this;
			this.first_count_el = $(o.first_selector, el);
			this.last_count_el = $(o.last_selector, el);
			this.total_count_el = $(o.total_selector, el);
			this.prev_button = $(o.previous_selector, el);
			this.next_button = $(o.next_selector, el);
			this.listings = $(o.listing_selector, el);
			this.tile_listings = $(o.tile_listing_selector, el);
			this.vertical_listings = $(o.vertical_listing_selector, el);
			this.listings_parent = this.listings.parent();
			this.sortby_select = $(o.sortby_selector, el);
			this.first_index = Number($(this.first_count_el[0]).html()) - 1;
			this.last_index = Number($(this.last_count_el[0]).html()) - 1;
			this.total_count = Number($(this.total_count_el[0]).html().replace(/[,]/g, ''));
			this.is_displet_api = (this.listings_parent.attr('is_displet_api') == 'false') ? false : true;

			if (this.total_count > 0) {
				this.rpp = this.last_index + 1;
				this.current_page = 1;

				// Sorting
				$(this.sortby_select, el).bind('change', function (ev) {
					if (this.value) {
						var original_query = self.prev_button.attr('displet_query');
						if (self.is_displet_api) {
							var start_check = /[?&]page=([^&]+)/i;
							var sort_check = /[?&]priceSorter=([^&]+)/i;
							var current_query = original_query.replace(start_check, '&page=1');
						}
						else{
							var start_check = /[?&]start=([^&]+)/i;
							var sort_check = /[?&]sort=([^&]+)/i;
							var current_query = original_query.replace(start_check, '&start=1');
						}
						// if price-desceding && no sort=price_reverse in query
						if (this.value == 'price-descending' && (current_query.indexOf('sort=price_reverse') === -1 || current_query.indexOf('priceSorter=desc') === -1)) {
							if (self.is_displet_api) {
								var new_sort = '&priceSorter=desc';
							}
							else{
								var new_sort = '&sort=price_reverse';
							}
							var new_query = current_query.replace(sort_check, '') + new_sort;
							loadDispletAPIListings(new_query, self.is_displet_api);
						}
						// if price-ascending && has sort=price_reverse in query (must check if sort=price_reverse to know that !sort=price isn't false positive for sort=price_reverse)
						else if (this.value == 'price-ascending' && current_query.indexOf('sort=price_reverse') !== -1) {
							var new_sort = '&sort=price';
							var new_query = current_query.replace(sort_check, '') + new_sort;
							loadDispletAPIListings(new_query, self.is_displet_api);
						}
						// if price-ascending && no sort=price in query
						else if (this.value == 'price-ascending' && (current_query.indexOf('sort=price') === -1 || current_query.indexOf('priceSorter=asc') === -1)) {
							if (self.is_displet_api) {
								var new_sort = '&priceSorter=asc';
							}
							else{
								var new_sort = '&sort=price';
							}
							var new_query = current_query.replace(sort_check, '') + new_sort;
							loadDispletAPIListings(new_query, self.is_displet_api);
						}
						// if date-desceding && no sort=ctime_reverse in query
						else if (this.value == 'date-descending' && current_query.indexOf('sort=ctime_reverse') === -1) {
							var new_sort = '&sort=ctime_reverse';
							var new_query = current_query.replace(sort_check, '') + new_sort;
							loadDispletAPIListings(new_query, self.is_displet_api);
						}
						// if date-ascending && has sort=ctime_reverse in query (must check if sort=ctime_reverse to know that !sort=ctime isn't false positive for sort=ctime_reverse)
						else if (this.value == 'date-ascending' && current_query.indexOf('sort=ctime_reverse') !== -1) {
							var new_sort = '&sort=ctime';
							var new_query = current_query.replace(sort_check, '') + new_sort;
							loadDispletAPIListings(new_query, self.is_displet_api);
						}
						// if date-ascending && no sort=ctime in query
						else if (this.value == 'date-ascending' && current_query.indexOf('sort=ctime') === -1) {
							var new_sort = '&sort=ctime';
							var new_query = current_query.replace(sort_check, '') + new_sort;
							loadDispletAPIListings(new_query, self.is_displet_api);
						}
						// If not search results page, update pagination URLs and browser URL
						if (self.prev_button.attr('href') != '#prev') {
							var next_url = self.next_button.attr('href');
							var page_match = /page\/(\d+)/;
							var sort_url = next_url.replace(page_match, '');
							previous_url = next_url.replace(page_match, '#previous'); // Using next_url to calc previous_url since always has page_match and never #previous
							next_url = next_url.replace(page_match, 'page/2');
							self.prev_button.attr('href', previous_url);
							self.next_button.attr('href', next_url);
							history.pushState('', 'New URL: ' + sort_url, sort_url);
						}
						if (new_sort != undefined) {
							$.cookie('displet_last_viewed_listings_sort', new_sort, {path: '/'});
						}
					}
				});

				// Price navigation
				$('#displet-price-navigation .displet-price-navigation').click(function(){
					if (!$(this).hasClass('active')) {
						$('#displet-price-navigation .displet-price-navigation.active').removeClass('active');
						self.update_prices($(this).attr('displetminprice'), $(this).attr('displetmaxprice'));
						$(this).addClass('active');
					}
				});

				$(this.next_button).click(function (ev) {
					self.next_page();
					ev.preventDefault();
					return false;
				});

				$(this.prev_button).click(function (ev) {
					self.prev_page();
					ev.preventDefault();
					return false;
				});

				window.onpopstate = function(event) {
					var raw_query = self.next_button.attr('displet_query');
					if (raw_query != null) {
						if (self.is_displet_api) {
							var number_check = /[?&]limit=([^&]+)/i;
							var start_check = /[?&]page=([^&]+)/i;
						}
						else{
							var number_check = /[?&]num=([^&]+)/i;
							var start_check = /[?&]start=([^&]+)/i;
						}
						var number_match = number_check.exec(raw_query);
						if (number_match != null) {
							var number = parseInt(number_match[1]);
						}
						if (location.pathname.indexOf('/page/') !== -1) {
							var page_match = /page\/(\d+)/;
							var page = location.pathname.match(page_match);
							var page_number = parseInt(page[1]);
							if (self.is_displet_api) {
								var new_start = '&page=' + page_number;
							}
							else{
								page_number--;
								var new_start = '&start=' + (number * page_number + 1);
							}
						}
						else{
							if (self.is_displet_api) {
								var new_start = '&page=1';
							}
							else{
								var new_start = '&start=1';
							}
						}
						var new_query = raw_query.replace(start_check, new_start);
						if (raw_query != new_query) {
							loadDispletAPIListings(new_query, self.is_displet_api);
						}
					}
				};

				this._size_listings();
				this._adjust_rpp();
				this._clear_float();
				this._make_pages();
				this.hovertrans();
			}
			else {
				this.first_count_el.html('0');
				this.last_count_el.html('0');
				this.total_count_el.html('0');
			}
		},
		'update_prices': function (min, max) {
			if (this.is_displet_api) {
				var min_price = parseInt(parseInt(min) / 1000);
				var max_price = parseInt(parseInt(max) / 1000);
				var original_query = this.prev_button.attr('displet_query');
				var start_check = /[?&]page=([^&]+)/i;
				var min_price_check = /[?&]minListPrice=([^&]+)/i;
				var max_price_check = /[?&]maxListPrice=([^&]+)/i;
				var current_query = original_query.replace(start_check, '&page=1').replace(min_price_check, '').replace(max_price_check, '');
				var new_query = current_query + '&minListPrice=' + min_price + '&maxListPrice=' + max_price;
				loadDispletAPIListings(new_query, this.is_displet_api);
				console.log(new_query);
			}
		},
		'hovertrans': function () {
			this._hovertrans();
		},
		'show_tile': function () {
			this._show_tile();
		},
		'show_vertical': function () {
			this._show_vertical();
		},
		'show_map': function () {
			this._show_map();
		},
		'_adjust_rpp': function () {
			if (this.listings_per_row != 0) {
				while (this.rpp % this.listings_per_row != 0) {
					this.rpp++;
				}
			}
		},
		'_size_listings': function () {
			var listings_per_row = 0;
			var target_width = 0;
			var margin_total = 0;
			var margin = 0;
			this.listing_width = $(this.tile_listings[0]).width() + 12;
			this.listings_parent_width = this.listings_parent.width();
			if (this.listing_width != 0) {
				this.listings_per_row = Math.floor(this.listings_parent_width / this.listing_width);
				target_width = Math.floor(this.listings_parent_width / this.listings_per_row);
				margin_total = target_width - this.listing_width;
				margin = Math.floor(margin_total / 2);
				this.tile_listings.css({
					'margin-left': margin,
					'margin-right': margin
				});
			}
		},
		'_clear_float': function () {
			var i = 1;
			var rowlength = this.listings_per_row;
			$(this.tile_listings).each(function(){
				$(this).removeClass('displet-clear');
				if (i % rowlength == 1) {
					$(this).addClass('displet-clear');
				}
				i++;
			});
		},
		'_make_pages': function () {
			this.pages = {};
			var pages_count = Math.ceil(this.total_count / this.rpp);
			this.pages_count = pages_count;
			var page = 1;
			this.pages[page] = [];
			for (var i = 0; i < this.total_count; i++) {
				if (i < (page * this.rpp)) {
					this.pages[page].push(i);
				}
				else {
					page++;
					this.pages[page] = [];
					this.pages[page].push(i);
				}
			}
		},
		'next_page': function () {
			this.listing_start = Number($(this.first_count_el[0]).html());
			this.listing_end = Number($(this.last_count_el[0]).html());
			this.listing_number = this.listing_end - this.listing_start;
			this.total_count = Number($(this.total_count_el[0]).html().replace(/[,]/g, ''));
			if ((this.listing_start + this.listing_number) <= this.total_count) {
				var raw_query = $(this.prev_button).attr('displet_query');
				if (this.is_displet_api) {
					var number_check = /[?&]limit=([^&]+)/i;
					var start_check = /[?&]page=([^&]+)/i;
				}
				else{
					var number_check = /[?&]num=([^&]+)/i;
					var start_check = /[?&]start=([^&]+)/i;
				}
				var number_match = number_check.exec(raw_query);
				if (number_match != null) {
					var number = parseInt(number_match[1]);
				}
				var start_match = start_check.exec(raw_query);
				if (start_match != null) {
					var start = parseInt(start_match[1]);
				}
				if (this.is_displet_api) {
					start++;
					var new_start = '&page=' + (start);
				}
				else{
					var new_start = '&start=' + (start + number);
				}
				var new_query = raw_query.replace(start_check, new_start);
				loadDispletAPIListings(new_query, this.is_displet_api);
				this._update_pagination_urls('next');
			}
		},
		'prev_page': function () {
			this.listing_start = Number($(this.first_count_el[0]).html());
			this.listing_end = Number($(this.last_count_el[0]).html());
			this.listing_number = this.listing_end - this.listing_start;
			if ((this.listing_start - this.listing_number) >= 1) {
				var raw_query = $(this.prev_button).attr('displet_query');
				if (this.is_displet_api) {
					var number_check = /[?&]limit=([^&]+)/i;
					var start_check = /[?&]page=([^&]+)/i;
				}
				else{
					var number_check = /[?&]num=([^&]+)/i;
					var start_check = /[?&]start=([^&]+)/i;
				}
				var number_match = number_check.exec(raw_query);
				if (number_match != null) {
					var number = parseInt(number_match[1]);
				}
				var start_match = start_check.exec(raw_query);
				if (start_match != null) {
					var start = parseInt(start_match[1]);
				}
				if (this.is_displet_api) {
					start--;
					var new_start = '&page=' + (start);
				}
				else{
					var new_start = '&start=' + (start - number);
				}
				var new_query = raw_query.replace(start_check, new_start);
				loadDispletAPIListings(new_query, this.is_displet_api);
				this._update_pagination_urls('previous');
			}
		},
		'_update_pagination_urls': function (direction) {
				var previous_url = this.prev_button.attr('href');
				var next_url = this.next_button.attr('href');
				var page_match = /page\/(\d+)/;
				// Update previous link
				if (previous_url.indexOf('/page/') !== -1) {
					if (direction == 'previous') {
						history.pushState('', 'New URL: ' + previous_url, previous_url);
					}
					var previous_page = previous_url.match(page_match);
					var previous_page_id = parseInt(previous_page[1]);
					if (direction == 'next') {
						previous_page_id++;
						previous_url = previous_url.replace(page_match, 'page/' + previous_page_id);
					}
					else{
						if (previous_page_id != 1) {
							previous_page_id--;
							previous_url = previous_url.replace(page_match, 'page/' + previous_page_id);
						}
						else{
							previous_url = previous_url.replace('page/1', '#previous');
						}
					}
					this.prev_button.attr('href', previous_url);
				}
				else {
					previous_url = previous_url.replace('#previous', 'page/1');
					this.prev_button.attr('href', previous_url);
				}
				// Update next link
				if (next_url.indexOf('/page/') !== -1) {
					if (direction == 'next') {
						history.pushState('', 'New URL: ' + next_url, next_url);
					}
					var next_page = next_url.match(page_match);
					var next_page_id = parseInt(next_page[1]);
					if (direction == 'next') {
						next_page_id++;
					}
					else{
						next_page_id--;	
					}
					next_url = next_url.replace(page_match, 'page/' + next_page_id);
					this.next_button.attr('href', next_url);
				}
		},
		'_hovertrans': function () {
			var self = this;
			$.each(this.listings, function(){
				var hovertrans = $(this).children('.displet-tile-hovertrans');
				$(hovertrans).children('.displet-inner').children('.displet-inner2').height($(hovertrans).parent('.displet-tile-listing').height() - 8);
				$(hovertrans).width($(hovertrans).parent('.displet-tile-listing').width() + 10);
				$(this).hover(
					function () {
						$(this).children('.displet-tile-hovertrans').stop(true, true).fadeIn(200);
					},
					function () {
						$(this).children('.displet-tile-hovertrans').stop(true, true).fadeOut(200);
					}
				);
				var hovertrans = $(this).children('.displet-listing-hovertrans');
				$(hovertrans).children('.displet-inner').children('.displet-inner2').css('width', $(hovertrans).parent('.displet-listing').width() + 14);
				$(hovertrans).children('.displet-inner').children('.displet-inner2').css('height', $(hovertrans).parent('.displet-listing').height() + 38);
				$(this).hover(
					function () {
						$(this).children('.displet-listing-hovertrans').stop(true, true).fadeIn(200);
						$(this).children('.displet-listing-info').children('.displet-text-overlay-hovertrans').fadeIn(200);
						$(this).children('.displet-listing-info').children('.displet-text-overlay').fadeOut(200);
					},
					function () {
						$(this).children('.displet-listing-hovertrans').stop(true, true).fadeOut(200);
						$(this).children('.displet-listing-info').children('.displet-text-overlay-hovertrans').fadeOut(200);
						$(this).children('.displet-listing-info').children('.displet-text-overlay').fadeIn(200);
					}
				);
			});
		},
		'_show_tile': function () {
			$('#displet-dynamic .displet-orientation .current').removeClass('current');
			$('#displet-dynamic .displet-tile-view').addClass('current');
			$('#displet-dynamic #displet-map').addClass('hiding');
			this.listings_parent.hide();
			this.vertical_listings.hide();
			this.listings.removeClass('displet-current');
			this.tile_listings.show();
			this.tile_listings.addClass('displet-current');
			this.listings_parent.removeClass('hiding');
			if (Number($(this.total_count_el[0]).html().replace(/[,]/g, '')) > 0) this.listings_parent.fadeIn(300);
			$.cookie('displet_last_viewed_listings_orientation', 'tile', {path: '/'});
		},
		'_show_vertical': function () {
			$('#displet-dynamic .displet-orientation .current').removeClass('current');
			$('#displet-dynamic .displet-list-view').addClass('current');
			$('#displet-dynamic #displet-map').addClass('hiding');
			this.listings_parent.hide();
			this.tile_listings.hide();
			this.listings.removeClass('displet-current');
			this.vertical_listings.show();
			this.vertical_listings.addClass('displet-current');
			this.listings_parent.removeClass('hiding');
			if (Number($(this.total_count_el[0]).html().replace(/[,]/g, '')) > 0) this.listings_parent.fadeIn(300);
			$.cookie('displet_last_viewed_listings_orientation', 'vertical', {path: '/'});
		},
		'_show_map': function () {
			$('#displet-dynamic .displet-orientation .current').removeClass('current');
			$('#displet-dynamic .displet-map-view').addClass('current');
			this.listings_parent.addClass('hiding');
			this.listings.removeClass('displet-current');
			$('#displet-dynamic #displet-map').hide();
			if (Number($(this.total_count_el[0]).html().replace(/[,]/g, '')) > 0) {
				$('#displet-dynamic #displet-map').removeClass('hiding');
				$('#displet-dynamic #displet-map').fadeIn(300);
			}
			$.cookie('displet_last_viewed_listings_orientation', 'map', {path: '/'});
		},
	});

	// Load listings and select view based on cookie history
	$(function () {
		if ($('#displet-dynamic').length) {
			$('#displet-dynamic .displet-listings-loading').show();
			$('#displet-dynamic').displet_listings();
			var last_viewed_orientation = $.cookie('displet_last_viewed_listings_orientation', {path: '/'});
			if (last_viewed_orientation == 'tile') {
				$('#displet-dynamic').data('displet_listings').show_tile();
			}
			else if (last_viewed_orientation == 'vertical') {
				$('#displet-dynamic').data('displet_listings').show_vertical();
			}
			else if (last_viewed_orientation == 'map') {
				$('#displet-dynamic').data('displet_listings').show_map();
			}
			$('#displet-dynamic .displet-listings-loading').fadeOut(300);
		}
	});
})(jQuery);

/*********************
Quick Search Functions
*********************/

function submitQSearch(url_base) {
	// Build the quick search parameters
	var url = url_base + '#';
	jQuery.each(jQuery('#displet-quick-search .dqs_displet'), function () {
		if (this.value != 'none' && this.value != '' && this.value != this.defaultValue && this.value != 'City, Zip Code, Neighborhood or Condo' && this.value != 'Ex. Pool, Modern, Foreclosure') {
			this.value = this.value.replace(' ', '%20');
			url += this.name + '=' + this.value + '/';
		}
	});
	location.replace(url);
	var current_url_base = 'http://' + window.location.hostname + window.location.pathname;
	if (current_url_base == url_base) {
		window.location.reload();	
	}
	else{
		window.location.load();
	}
}

jQuery(document).ready(function($){
	// Clear form on reload
	$('#displet-quick-search input').val(''); 
	$('#displet-quick-search select').val('none');	
	// Submit quick search on button click
	$('#displet-quick-search .action a').click(function(e) {
		e.preventDefault();
		submitQSearch($(this).attr('href'));
		return false;
	});
	// Submit quick search on enter key
	$('#displet-quick-search').keypress(function(e) {
		if (e.which == 13) {
			e.preventDefault();
			submitQSearch($(this).find('.action').children('a').attr('href'));
			return false;
		}
	});
	// Submit quick search on spacebar key when button selected
	$('#displet-quick-search .action a').keypress(function(e) {
		if (e.which == 32) {
			e.preventDefault();
			submitQSearch($(this).attr('href'));
			return false;
		}
	});
});

/*********************
Sidescroller Widget Functions
*********************/

jQuery(document).ready(function($){
	// Carousel
	try {
		$(".displet-listings-carousel").each(function(){
			$(this).displetRetsIdxCarouselLite({
			    btnNext: "a.displet-navigation-next",
			    btnPrev: "a.displet-navigation-previous",
			    visible: 1,
			    auto: 5000
			});
		});
  	}
  	catch(e){}
});

/*********************
Displet Carousel Functions
*********************/

(function($) {
    $.fn.displetRetsIdxCarouselLite = function(o) {
        o = $.extend({
            btnPrev: null,
            btnNext: null,
            btnGo: null,
            mouseWheel: false,
            auto: null,
            speed: 200,
            easing: null,
            vertical: false,
            circular: true,
            visible: 3,
            start: 0,
            scroll: 1,
            beforeStart: null,
            afterEnd: null
        },
        o || {});
        return this.each(function() {
            var running = false,
            animCss = o.vertical ? "top": "left",
            sizeCss = o.vertical ? "height": "width";
            var div = $(this),
            a = $("a", div),
            ul = $("ul", div),
            tLi = $("li", ul),
            tl = tLi.size(),
            v = o.visible;
            if (o.circular) {
                ul.prepend(tLi.slice(tl - v - 1 + 1).clone()).append(tLi.slice(0, v).clone());
                o.start += v;
            }
            var li = $("li", ul),
            itemLength = li.size(),
            curr = o.start;
            div.css("visibility", "visible");
            li.css({
                overflow: "hidden",
                float: o.vertical ? "none": "left"
            });
            ul.css({
                margin: "0",
                padding: "0",
                position: "relative",
                "list-style-type": "none",
                "z-index": "1"
            });
            div.css({
                overflow: "hidden",
                position: "relative",
                "z-index": "2",
                left: "0px"
            });
            var liSize = o.vertical ? height(li) : width(li);
            var ulSize = liSize * itemLength;
            var divSize = liSize * v;
            li.css({
                width: li.width(),
                height: li.height()
            });
            ul.css(sizeCss, ulSize + "px").css(animCss, -(curr * liSize));
            div.css(sizeCss, divSize + "px");
            var self = this;
            if (o.btnPrev) $(o.btnPrev, div).click(function() {
                clearInterval(self.autoScroll);
                return go(curr - o.scroll);
            });
            if (o.btnNext) $(o.btnNext, div).click(function() {
                clearInterval(self.autoScroll);
                return go(curr + o.scroll);
            });
            if (o.btnGo) $.each(o.btnGo,
            function(i, val) {
                $(val).click(function() {
                    return go(o.circular ? o.visible + i: i);
                });
            });
            if (o.mouseWheel && div.mousewheel) div.mousewheel(function(e, d) {
                return d > 0 ? go(curr - o.scroll) : go(curr + o.scroll);
            });
            if (o.auto) {
                self.autoScroll = setInterval(function() {
                    go(curr + o.scroll);
                },
                o.auto + o.speed);
                div.hover(
                    function() {
                        clearInterval(self.autoScroll);
                    },
                    function() {
                        self.autoScroll = setInterval(function() {
                            go(curr + o.scroll);
                        }, o.auto + o.speed);
                });
            }
            function vis() {
                return li.slice(curr).slice(0, v);
            };
            function go(to) {
                if (!running) {
                    if (o.beforeStart) o.beforeStart.call(this, vis());
                    if (o.circular) {
                        if (to <= o.start - v - 1) {
                            ul.css(animCss, -((itemLength - (v * 2)) * liSize) + "px");
                            curr = to == o.start - v - 1 ? itemLength - (v * 2) - 1: itemLength - (v * 2) - o.scroll;
                        } else if (to >= itemLength - v + 1) {
                            ul.css(animCss, -((v) * liSize) + "px");
                            curr = to == itemLength - v + 1 ? v + 1: v + o.scroll;
                        } else curr = to;
                    } else {
                        if (to < 0 || to > itemLength - v) return;
                        else curr = to;
                    }
                    running = true;
                    ul.animate(animCss == "left" ? {
                        left: -(curr * liSize)
                    }: {
                        top: -(curr * liSize)
                    },
                    o.speed, o.easing,
                    function() {
                        if (o.afterEnd) o.afterEnd.call(this, vis());
                        running = false;
                    });
                    if (!o.circular) {
                        $(o.btnPrev + "," + o.btnNext).removeClass("disabled");
                        $((curr - o.scroll < 0 && o.btnPrev) || (curr + o.scroll > itemLength - v && o.btnNext) || []).addClass("disabled");
                    }
                }
                return false;
            };
        });
    };
    function css(el, prop) {
        return parseInt($.css(el[0], prop)) || 0;
    };
    function width(el) {
        return el[0].offsetWidth + css(el, 'marginLeft') + css(el, 'marginRight');
    };
    function height(el) {
        return el[0].offsetHeight + css(el, 'marginTop') + css(el, 'marginBottom');
    };
})(jQuery);