<script>
function renderDispletMap(displet_map_listings_array, current_lat_total, current_long_total) {
	if (displet_map_listings_array.length !== -1) {
		var first = true;
		var bounds = new google.maps.LatLngBounds();
		var lat_average = current_lat_total / displet_map_listings_array.length;
		var long_average = current_long_total / displet_map_listings_array.length;
		var variance = <?php echo $model['map_variance']; ?>;

		// Plot marker and bounds for each listing
		for (var i = 0; i < displet_map_listings_array.length; i++){
			if (displet_map_listings_array[i][0] != null && displet_map_listings_array[i][1] != null && displet_map_listings_array[i][0] > (lat_average - variance) && displet_map_listings_array[i][0] < (lat_average + variance) && displet_map_listings_array[i][1] > (long_average - variance) && displet_map_listings_array[i][1] < (long_average + variance)) {
				var listing_lat_long = new google.maps.LatLng(displet_map_listings_array[i][0], displet_map_listings_array[i][1]);

				// Create map if first lat/long
				if (first) {
					var map = new google.maps.Map(document.getElementById('map_canvas'), {
    					zoom: 12,
    					center: listing_lat_long,
    					mapTypeId: google.maps.MapTypeId.ROADMAP
					});
					var first = false;
				}
				
				var marker = new google.maps.Marker({
					map: map,
					position: listing_lat_long,
					price: displet_map_listings_array[i][2],
					address: displet_map_listings_array[i][3]
				});
				google.maps.event.addListener(marker, 'click', function() {
					onMarkerClick(this, this.price, this.address);
				});
				bounds.extend(listing_lat_long);
			}
		}

		if (marker != undefined){
			// Interpret markers
	    	var infoWindow = new google.maps.InfoWindow;
	    	function onMarkerClick(marker, price, address) {
	    		var latLng = marker.getPosition();
	    		infoWindow.setContent('<div class="marker-inner"><h3>$' + displetretsidxCommasToNumber(price) + '</h3><h4>' + address + '</h4></div>');
	    		infoWindow.open(map, marker);
	    	};
	
	    	google.maps.event.addListener(map, 'click', function() {
	    		infoWindow.close();
	    	});
	
	    	// Fit to bounds
			map.fitBounds(bounds);
		}
	}
}
</script>